require_relative 'hyde'

server = Hyde::Server.new Port: 8000 do
  root Dir::pwd+"/test/"
  serve "index.html"
  index ["index.html"]
  path "about" do
    serve "webrick" do |ctx|
      ctx.response.body = "WEBrick is a modular http server stack"
      ctx.response['Content-Type'] = "text/plain"
    end
    serve "hyde" do |ctx|
      ctx.response.body = "Hyde is the disgusting side of Jekyll, and, by extension, the thing that makes WEBrick usable."
      ctx.response['Content-Type'] = "text/plain"
    end
  end
  path "uploads" do
    preprocess { |request| puts request.inspect }
    index ["index.html"]
    serve ["**/*.md","*.html","**/*.html"], match_full_path: true
  end
  path ["vars_1","vars_2"] do
    preprocess do |request|
      request.vars["flag"] = "yes" if request.filepath.match "vars_1"
    end
    serve "view" do |ctx|
      ctx.response.body = "Flag: #{ctx.vars["flag"]}"
      ctx.response['Content-Type'] = "text/plain"
    end
  end
end

server.start
