require_relative "hyde"
path = Hyde::Pathspec.new "/" do
  root "/var/www"
  path "about" do
    printProbe "test"
    printProbe "test_*"
  end
  path "docs" do
    remap "/var/www/markdown_compiled/"
    printProbe "test"
    printProbe "test_*"
    probe "speen" do |request|
      puts "maurice spinning"
      redirect "https://www.youtube.com/watch?v=KeNyN_rVL_c"
      pp request
    end
  end
  path "cell_1337" do
    root "/var/www/cells"
    path "control" do
      probe "close" do |request|
        puts "Permissions level 4 required to control this cell"
        pp request 
      end
      probe "open" do |request|
        puts "Permissions level 4 required to control this cell"
        pp request
      end
    end
    printProbe "info"
  end
  path (/cell_[^\/]*/) do
    root "/var/www/cells"
    path "control" do
      probe "close" do |request|
        puts "Closing cell #{request.filepath.match /cell_[^\/]*/}"
        pp request
      end
      probe "open" do |request|
        puts "Opening cell #{request.filepath.match /cell_[^\/]*/}"
        pp request
      end
    end
    printProbe "dura"
    printProbe "info"
  end
  path "bad_?" do
    printProbe "path"
  end
  probe ["info","hyde"] do
    puts "this is the most disgusting and visceral thing i've written yet, and i love it"
  end
end

[
  Hyde::Request.new("/about/speen",nil,nil),
  Hyde::Request.new("/about/test",nil,nil),
  Hyde::Request.new("/about/test_2",nil,nil),
  Hyde::Request.new("/docs/speen",nil,nil),
  Hyde::Request.new("/docs/test",nil,nil),
  Hyde::Request.new("/docs/test_3",nil,nil),
  Hyde::Request.new("/cell_41/control/open",nil,nil),
  Hyde::Request.new("/cell_21/control/close",nil,nil),
  Hyde::Request.new("/cell_19283/info",nil,nil),
  Hyde::Request.new("/cell_1337/control/close",nil,nil),
  Hyde::Request.new("/duracell_129/control/open",nil,nil),
  Hyde::Request.new("/duracell_1447/control/close",nil,nil),
  Hyde::Request.new("/bad_2path",nil,nil),
  Hyde::Request.new("/info",nil,nil),
  Hyde::Request.new("/hyde",nil,nil)
].each { |x| path.match(x) }
# what a load of fuck this is
